#! /bin/bash
# Script to set Node capability for OSP node placement 
# Author : Guilherme Giacon
#
# This script must be executed after introspection with all nodes in provide (available) state
# IMPORTANT
#  ***** first three nodes in instackenv.json must be the controllers, all other are compute nodes
#
. /home/stack/stackrc
echo "#! /bin/bash" > ./set_cap.sh
chmod +x ./set_cap.sh
NODE_IDX=0
COMPUTE_IDX=0
for NODE_ID in $(openstack baremetal node list | awk '/available/ {print $2}')
do
  if [ "$NODE_IDX" -le 2 ]; then 
    echo "openstack baremetal node set --property capabilities='node:controller-$NODE_IDX,boot_option:local' $NODE_ID" >> ./set_cap.sh
    let NODE_IDX=$NODE_IDX+1
  else
      echo "openstack baremetal node set --property capabilities='node:compute-$COMPUTE_IDX,boot_option:local' $NODE_ID" >> ./set_cap.sh
      let COMPUTE_IDX=$COMPUTE_IDX+1
  fi
done;
