#!/bin/bash

set -x

ipv4=${EXTERNAL_IPV4}
iface=${EXTERNAL_IFACE}

bootstrap_nodeid=$(hiera bootstrap_nodeid)

if [[ "x$(grep ${ipv4} /etc/haproxy/haproxy.cfg)" == x  ]]; then
  ipv6=$(cat /etc/haproxy/haproxy.cfg | awk '/:13000/ { print $2 }' |grep '2001:4888' | cut -d':' -f1-8)
  sed -i.bak "/.*bind ${ipv6}:35357.*/d" /etc/haproxy/haproxy.cfg
  sed -i "s/.*bind ${ipv6}:\([0-9]*\) \(.*\)/&\n  bind ${ipv4}:\1 \2/" /etc/haproxy/haproxy.cfg
  #sed -i '/user  haproxy/a\  ssl-default-bind-options no-sslv3 no-tls-tickets no-tlsv10\n  ssl-default-bind-ciphers ALL:!EXP:!NULL:!ADH:!LOW:!SSLv2:!SSLv3:!MD5:!RC4' /etc/haproxy/haproxy.cfg
  sed -i '/^listen cinder/a\  timeout client 3m\n  timeout server 3m' /etc/haproxy/haproxy.cfg

  #if [ $(hostname -s | egrep -o 'ocld-[0-9]' | grep -o '[0-9]') -eq 0 ]; then
  if [[ "$(hostname -s)" == "${bootstrap_nodeid}" ]]; then
    sleep 30 # Wait for pacemaker
    pcs resource create ip-${ipv4} IPaddr2 ip="${ipv4}" cidr_netmask=32 nic=${iface} op monitor interval=30s
    pcs resource restart haproxy-clone
  fi
fi
