file { '/etc/multipath.conf':
         notify => Service['multipathd'],
         content => '
blacklist {
        devnode "^(ram|raw|loop|fd|md|dm-|sr|scd|st)[0-9]*"
        devnode "^hd[a-z][0-9]*"
        devnode "^cciss!c[0-9]d[0-9]*[p[0-9]*]"
        devnode "^(td|hd|vd)[a-z]"
        devnode "^dcssblk[0-9]*"
        device {
                vendor "DGC"
                product "LUNZ"
        }
        device {
                vendor "HP iLO"
                product ".*"
        }
        device {
                vendor "HP"
                product "LOGICAL VOLUME"
        }
}

defaults {
        user_friendly_names no
        flush_on_last_del yes
}

devices {
        # Device attributed for EMC CLARiiON and VNX series ALUA
        device {
                vendor "DGC"
                product ".*"
                product_blacklist "LUNZ"
                path_grouping_policy group_by_prio
                path_selector "round-robin 0"
                path_checker emc_clariion
                features "1 queue_if_no_path"
                hardware_handler "1 alua"
                prio alua
                failback immediate
        }
}
'
}

service { 'multipathd':
            ensure => 'running',
            enable => true,
}

file { '/etc/modprobe.d/blacklist.conf':
         content => '
blacklist ixgbevf
'
}
