#!/bin/sh
source ${HOME}/overcloudrc || exit 127

PATTERN=$(hostname -s | cut -d'-' -f1)-h-pe4c7cn

#for i in $(openstack aggregate list | egrep 'Active|Maintenance' | awk '{print $4}'); do
#  openstack aggregate show $i | egrep -o "${PATTERN}-[0-9]+\.localdomain" | xargs -I% -P32 bash -c "openstack aggregate delete $i %; ssh % 'sudo openstack-config --set /etc/nova/nova.conf DEFAULT vcpu_pin_set 2-11,14-23,26-35,38-47; sudo systemctl restart openstack-nova-compute'"
#done

for i in Active{,-{A,B}} Active-Pin-Isolate{,-{A,B}} Maintenance{,-{A,B}}; do
  openstack aggregate delete $i
done

openstack aggregate create --zone Zone-A Active-A
openstack aggregate create --zone Zone-B Active-B
openstack aggregate create --zone Zone-PI-A Active-Pin-Isolate-A
openstack aggregate create --zone Zone-PI-B Active-Pin-Isolate-B
openstack aggregate create --zone Zone-M-A Maintenance-A
openstack aggregate create --zone Zone-M-B Maintenance-B

openstack aggregate create Active
openstack aggregate create Active-Pin-Isolate
openstack aggregate create Maintenance

for i in ${PATTERN}-{0..14}.localdomain; do
  nova aggregate-add-host Active-A $i &
  nova aggregate-add-host Active $i &
done

for i in ${PATTERN}-{15..29}.localdomain; do
  nova aggregate-add-host Active-B $i &
  nova aggregate-add-host Active $i &
done

for i in ${PATTERN}-{30..38}.localdomain; do
  nova aggregate-add-host Active-Pin-Isolate-A $i &
  ssh $i "sudo openstack-config --set /etc/nova/nova.conf DEFAULT vcpu_pin_set 2-11,14-23; sudo systemctl restart openstack-nova-compute" &
  nova aggregate-add-host Active-Pin-Isolate $i &
done

for i in ${PATTERN}-{39..47}.localdomain; do
  nova aggregate-add-host Active-Pin-Isolate-B $i &
  ssh $i "sudo openstack-config --set /etc/nova/nova.conf DEFAULT vcpu_pin_set 2-11,14-23; sudo systemctl restart openstack-nova-compute" &
  nova aggregate-add-host Active-Pin-Isolate $i &
done

for i in ${PATTERN}-{48..55}.localdomain; do
  nova aggregate-add-host Maintenance-A $i &
  nova aggregate-add-host Maintenance $i &
done

for i in ${PATTERN}-{56..63}.localdomain; do
  nova aggregate-add-host Maintenance-B $i &
  nova aggregate-add-host Maintenance $i &
done

for i in Active{,-{A,B}} Active-Pin-Isolate{,-{A,B}} Maintenance{,-{A,B}}; do
  nova aggregate-set-metadata $i cpu_allocation_ratio=1.0 &
done

for i in Active Active-Pin-Isolate Maintenance; do
  nova aggregate-set-metadata $i $i=true &
done

sleep 5
echo Done.
