#!/bin/bash

USERNAME=OSPctl
PASSWORD="SMITH-here"
SSH_CMD="ssh -l heat-admin"

function enable_stonith {

  HOST=$1

  NAME=$(${SSH_CMD} ${HOST} hostname -s)

  # get the ipv4 ilo addr
  ADDR=$(${SSH_CMD} ${HOST} sudo ipmitool lan print | awk -F' +: ' '$1 == "IP Address" {print $2}')
  ILO_URL=https://${ADDR}/ribcl
  # get the ipv6 ilo addr
  ILO_ADDR=$( curl -sk -X POST -d \
  "<RIBCL VERSION=\"2.0\">
    <LOGIN USER_LOGIN=\"${USERNAME}\" PASSWORD=\"${PASSWORD}\">
      <RIB_INFO MODE=\"read\">
        <GET_NETWORK_SETTINGS/>
      </RIB_INFO>
    </LOGIN>
  </RIBCL>" ${ILO_URL} | sed -n 's/.*<IPV6_ADDRESS.*VALUE="\([^"]*\)".*/\1/gp' |grep -vi fe80 )
  # create the fence device
  $SSH_CMD ${HOST} "sudo pcs stonith create stonith-${NAME} fence_ilo4_ssh pcmk_host_list=${NAME} secure=1 inet6_only=1 ipaddr='${ILO_ADDR}' login=${USERNAME} passwd='${PASSWORD}' op monitor interval=60s"
  # avoid fencing yourself
  $SSH_CMD ${HOST} "sudo pcs constraint location stonith-${NAME} avoids ${NAME}"

}

source ~/stackrc
for i in $(nova list | awk '/ocld/ {split($12,x,"="); print x[2]}'); do
  echo "Creating STONITH device for $i"
  enable_stonith $i
done

# enable STONITH from any controller
$SSH_CMD $i 'sudo pcs property set stonith-enabled=true'
$SSH_CMD $i 'sudo pcs property show'
$SSH_CMD $i 'sudo pcs stonith show'
